<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: Getting started with Moco</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_developer.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For C++ developers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('mocogettingstarted.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">Getting started with Moco </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><h1><a class="anchor" id="obtaining"></a>
Obtaining Moco</h1>
<p>Download Moco for Windows or Mac from <a href="https://simtk.org/projects/opensim-moco">https://simtk.org/projects/opensim-moco</a>. The Moco distribution contains a MATLAB/Java package, a Python package, a C++ library, and a command-line tool. Currently, Moco does not have a graphical user interface.</p>
<p>The distribution is a ZIP file that you can place anywhere on your computer; for example, <code>C:/Users/&lt;username&gt;/opensim-moco-&lt;version&gt;</code> on Windows or <code>/Users/&lt;username&gt;/opensim-moco-&lt;version&gt;</code> on Mac. We refer to this location</p>
<dl class="section note"><dt>Note</dt><dd>On Windows, set your Windows PATH environment variable to include <code>&lt;OpenSim-Moco-Install&gt;/bin</code> before any other OpenSim/OpenSense paths.</dd></dl>
<p>Decide which of Moco's interfaces you want to use and follow the relevant instructions below.</p>
<h1><a class="anchor" id="buildingfromsource"></a>
Building Moco from source</h1>
<p>If you want to edit Moco's C++ code or use Moco on a platform for which we do not distribute binaries (e.g., Linux), then you must build Moco from source. Developing your own cost module does not require building Moco from source.</p>
<p>For instructions, visit the source code repository at <a href="https://github.com/opensim-org/opensim-core">https://github.com/opensim-org/opensim-core</a> and consult the README.md file.</p>
<h1><a class="anchor" id="usingmatlab"></a>
Using Moco in MATLAB</h1>
<p>Follow the instructions for configuring Matlab to use <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a>: <a href="https://simtk-confluence.stanford.edu:8443/display/OpenSim/Scripting+with+Matlab">https://simtk-confluence.stanford.edu:8443/display/OpenSim/Scripting+with+Matlab</a></p>
<p>Restart Matlab and test that Matlab is properly configured to use <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> by running:</p>
<div class="fragment"><div class="line">&gt;&gt; org.opensim.modeling.opensimCommon.GetVersionAndDate(); </div>
</div><!-- fragment --><p>Make sure the output is consistent with the version of <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> you intend to use.</p>
<p>The <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> distribution contains Matlab examples in the folder <code>Resources/Code/Matlab/Moco</code>. Start with <code>exampleSlidingMass.m</code>.</p>
<h1><a class="anchor" id="usingpython"></a>
Using Moco in Python</h1>
<p>To use the Python package that comes with the Moco distribution, you must use the same Python distribution with which Moco was built. For Windows, this is the Python 3 distribution from python.org. For Mac, this is the Python 3 package from Homebrew.</p>
<p>The <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> distribution contains Moco Python examples in the folder <code>Resources/Code/Python/Moco</code>. Start with <code>exampleSlidingMass.py</code>.</p>
<p>If you would prefer to use Python 2 instead of Python 3, you must build from source using the instructions in the README.md file of the opensim-core source code repository (<a href="https://github.com/opensim-org/opensim-core/blob/master/README.md">https://github.com/opensim-org/opensim-core/blob/master/README.md</a>).</p>
<p>In the future, we hope to make the Python package easier to install by distributing it through the Conda package manager.</p>
<h1><a class="anchor" id="usingcpp"></a>
Using Moco in C++</h1>
<p>This section is under development. </p>
</div></div><!-- contents -->
</div><!-- PageDoc -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="mocomainpage.html">Moco</a></li><li class="navelem"><a class="el" href="mocouserguide.html">Moco User Guide</a></li>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:16 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
